Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports C1.Win.C1FlexGrid

Partial Public Class Form1
    Inherits Form
    Public Sub New()
        InitializeComponent()
    End Sub
    Private Sub Form1_Load(sender As Object, e As EventArgs)

        '' Styles for Links which are yet to be visited
        Dim cs As CellStyle = _flex.Styles.Add("NewLink")
        cs.Font = New Font(_flex.Font, FontStyle.Underline)
        cs.ForeColor = Color.Blue
        cs.TextAlign = TextAlignEnum.RightCenter

        '' Styles for Links which are visited
        cs = _flex.Styles.Add("OldLink")
        cs.Font = New Font(_flex.Font, FontStyle.Underline)
        cs.ForeColor = Color.Purple
        cs.TextAlign = TextAlignEnum.RightCenter

        Dim grid As C1FlexGrid = Me._flex
        grid.VisualStyle = VisualStyle.System
        grid.Styles.Normal.WordWrap = True
        grid.Cols.Count = 3
        grid.Rows.Count = 4
        grid.Rows.Fixed = 1
        grid.Styles.Fixed.TextAlign = TextAlignEnum.CenterCenter
        AddHandler grid.MouseMove, AddressOf _flex_MouseMove
        AddHandler grid.MouseDown, AddressOf _flex_MouseDown
        grid.DrawMode = DrawModeEnum.OwnerDraw
        AddHandler grid.OwnerDrawCell, AddressOf _flex_OwnerDrawCell

        Dim rng As CellRange
        rng = grid.GetCellRange(0, 1)
        rng.Data = "Web Links"

        rng = grid.GetCellRange(1, 1)
        rng.UserData = New HyperLinkData() With {.Visited = False, .URL = "http://www.google.com"}
        rng.Data = "Google"

        rng = grid.GetCellRange(2, 1)
        rng.UserData = New HyperLinkData() With {.Visited = False, .URL = "http://www.msdn.microsoft.com"}
        rng.Data = "MSDN"
        rng = grid.GetCellRange(3, 1)
        rng.UserData = New HyperLinkData() With {.Visited = False, .URL = "http://www.youtube.com"}
        rng.Data = "Youtube"
    End Sub
    Private Sub _flex_MouseMove(sender As Object, e As System.Windows.Forms.MouseEventArgs)
        Dim ht As HitTestInfo = _flex.HitTest(e.X, e.Y)
        Dim hand As Boolean = False
        If (ht.Type).Equals(HitTestTypeEnum.Cell) AndAlso (ht.Column).Equals(1) Then
            Dim cr As CellRange = _flex.GetCellRange(ht.Row, ht.Column)
            If (cr.UserData.[GetType]()).Equals(GetType(HyperLinkData)) Then
                Using g As Graphics = _flex.CreateGraphics()
                    Dim rc As Rectangle = _flex.GetCellRect(ht.Row, ht.Column, False)
                    Dim width As Integer = CType(g.MeasureString(cr.DataDisplay, _flex.Font).Width, Integer)
                    If rc.Right - e.X <= width Then
                        hand = True
                    End If
                End Using
            End If
        End If
        Cursor = If((hand), Cursors.Hand, Cursors.[Default])
    End Sub
    Private Sub _flex_MouseDown(sender As Object, e As System.Windows.Forms.MouseEventArgs)
        If (Cursor).Equals(Cursors.Hand) Then
            Dim ht As HitTestInfo = _flex.HitTest(e.X, e.Y)
            If (ht.Type).Equals(HitTestTypeEnum.Cell) AndAlso (ht.Column).Equals(1) Then
                Dim cr As CellRange = _flex.GetCellRange(ht.Row, ht.Column)
                If (cr.UserData.[GetType]()).Equals(GetType(HyperLinkData)) Then
                    System.Diagnostics.Process.Start(CType(cr.UserData, HyperLinkData).url)
                    CType(cr.UserData, HyperLinkData).Visited = True
                End If
            End If
        End If
    End Sub
    Private Sub _flex_OwnerDrawCell(sender As Object, e As C1.Win.C1FlexGrid.OwnerDrawCellEventArgs)
        If (e.Col).Equals(1) AndAlso e.Row >= _flex.Rows.Fixed Then
            Dim cr As CellRange = _flex.GetCellRange(e.Row, e.Col)
            If (cr.UserData.[GetType]()).Equals(GetType(HyperLinkData)) Then
                If ((TryCast(cr.UserData, HyperLinkData)).Visited).Equals(True) Then
                    e.Style = _flex.Styles("OldLink")
                Else
                    e.Style = _flex.Styles("NewLink")
                End If
            End If
        End If
    End Sub
End Class
Public Class HyperLinkData
    Dim _visit As Boolean
    Public Property Visited() As Boolean
        Get
            Return _visit
        End Get
        Set(value As Boolean)
            _visit = value
        End Set
    End Property

    Dim _url As String
    Public Property URL() As String
        Get
            Return _url
        End Get
        Set(value As String)
            _url = value
        End Set
    End Property
End Class

